package hib.inher.jpa.two;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

public class TestTwo {
    public static void main(String[] args) {
    	EntityManagerFactory factory = Persistence.createEntityManagerFactory("animals");
    	EntityManager em = factory.createEntityManager();
        // get one
        System.out.println("2 x One:");
        Animal a1 = em.find(Animal.class, 1);
        System.out.println(a1);
        Cat a2 = em.find(Cat.class, 1);
        System.out.println(a2);
        // get all
        System.out.println("All:");
        @SuppressWarnings("unchecked")
		List<Animal> a3list = em.createQuery("SELECT a FROM Animal AS a").getResultList();
        for(Animal a3 : a3list) {
            System.out.println(a3);
        }
        // get some
        System.out.println("2 x Some:");
        Query q = em.createQuery("SELECT a FROM Animal AS a WHERE name LIKE :name");
        q.setParameter("name", "K%");
        @SuppressWarnings("unchecked")
		List<Animal> a4list = q.getResultList();
        for(Animal a4 : a4list) {
            System.out.println(a4);
        }
        CriteriaBuilder cb = em.getCriteriaBuilder();
        CriteriaQuery<Animal> cq = cb.createQuery(Animal.class);
        cq.where(cb.like(cq.from(Animal.class).<String>get("name"), "K%"));
		List<Animal> a5list = em.createQuery(cq).getResultList();
        for(Animal a5 : a5list) {
            System.out.println(a5);
        }
        // SQL
        System.out.println("SQL:");
        Query sq = em.createNativeQuery("SELECT id,name,typ,miceperday,litermilkperday FROM animal_one WHERE name LIKE :name");
        sq.setParameter("name", "K%");
        @SuppressWarnings("unchecked")
		List<Object[]> a8list = sq.getResultList();
        for(Object[] row : a8list) {
        	Animal a8;
        	int typ = (Integer)row[2];
        	if(typ == 1) {
        		Cat res = new Cat();
        		res.setId((Integer)row[0]);
        		res.setName((String)row[1]);
        		res.setMiceperday((Integer)row[3]);
        		a8 = res;
        	} else if(typ == 2) {
        		Cow res = new Cow();
        		res.setId((Integer)row[0]);
        		res.setName((String)row[1]);
        		res.setLitermilkperday((Integer)row[4]);
        		a8 = res;
        	} else {
                throw new RuntimeException("WTF");
        	}
            System.out.println(a8);
        }
        //
        em.close();
    }
}
